;===================================================================================
Func GradientRefresh()
	Local $farbe, $left, $middle, $right, $width, $height = 88
	Local $r, $g, $b, $i, $j, $x
	Local $diff, $diff_r, $diff_g, $diff_b, $mid_r, $mid_g, $mid_b
	GUICtrlDelete($GradView)
	$GradView = GUICtrlCreateGraphic(16, 22, 512, $height, 0x1000)
	For $i = 0 To $segments - 1
		$r = $gradient[$i][4]
		$g = $gradient[$i][5]
		$b = $gradient[$i][6]
		$left = Round($gradient[$i][1] * 512, 0)
		$middle = Round($gradient[$i][2] * 512, 0)
		$right = Round($gradient[$i][3] * 512, 0)
		$diff = $middle - $left + ($right - $left) / 2
		If $diff < 2 And $diff > -2 Then
			$width = $right - $left
			;MsgBox(16,"",$width)
			$diff_r = ($gradient[$i][4] - $gradient[$i][8]) / $width
			$diff_g = ($gradient[$i][5] - $gradient[$i][9]) / $width
			$diff_b = ($gradient[$i][6] - $gradient[$i][10]) / $width
			;MsgBox(16,"",$abstand)
			For $j = 0 To $width
				$r -= $diff_r
				$g -= $diff_g
				$b -= $diff_b
				$farbe = rgb2hex($r, $g, $b)
				GUICtrlSetGraphic($GradView, $GUI_GR_COLOR, $farbe, $farbe)
				$x = $left + $j
				If $x < 512 Then GUICtrlSetGraphic($GradView, $GUI_GR_RECT, $x, 0, 1, $height)
			Next
		Else
			$width = $middle - $left
			$mid_r = ($gradient[$i][4] + $gradient[$i][8]) / 2
			$mid_g = ($gradient[$i][5] + $gradient[$i][9]) / 2
			$mid_b = ($gradient[$i][6] + $gradient[$i][10]) / 2
			$diff_r = ($gradient[$i][4] - $mid_r) / $width
			$diff_g = ($gradient[$i][5] - $mid_g) / $width
			$diff_b = ($gradient[$i][6] - $mid_b) / $width
			For $j = 0 To $width
				$r -= $diff_r
				$g -= $diff_g
				$b -= $diff_b
				$farbe = rgb2hex($r, $g, $b)
				GUICtrlSetGraphic($GradView, $GUI_GR_COLOR, $farbe, $farbe)
				$x = $left + $j
				If $x < 512 Then GUICtrlSetGraphic($GradView, $GUI_GR_RECT, $x, 0, 1, $height)
			Next
			$width = $right - $middle
			;MsgBox(16,"",$width)
			$diff_r = ($mid_r - $gradient[$i][8]) / $width
			$diff_g = ($mid_g - $gradient[$i][9]) / $width
			$diff_b = ($mid_b - $gradient[$i][10]) / $width
			;MsgBox(16,"",$abstand)
			For $j = 0 To $width
				$r -= $diff_r
				$g -= $diff_g
				$b -= $diff_b
				$farbe = rgb2hex($r, $g, $b)
				GUICtrlSetGraphic($GradView, $GUI_GR_COLOR, $farbe, $farbe)
				$x = $middle + $j
				;LogEntry($x & " " & $farbe &@CRLF,0)
				If $x < 512 Then GUICtrlSetGraphic($GradView, $GUI_GR_RECT, $x, 0, 1, $height)
			Next
		EndIf
	Next
	GUICtrlSetGraphic($GradView, $GUI_GR_REFRESH)
	Return
EndFunc   ;==>GradientRefresh
;=======================================================================================
; Statusanzeige
Func SetStatusMessage($text = "", $nr = 0)
	Local $Max = 60
	If StringLen($text) < $Max Then
		_GUICtrlStatusBar_SetText($Status, $text, $nr)
	Else
		_GUICtrlStatusBar_SetText($Status, "..." & StringRight($text, $Max), $nr)
	EndIf
	Return
EndFunc   ;==>SetStatusMessage
;=======================================================================================
;RGB Werte nach HEX (0xffffff) Werte von 0 - 1
Func rgb2hex($r, $g, $b)
	If $r > 1 Then
		$r = 1
	ElseIf $r < 0 Then
		$r = 0
	EndIf
	If $g > 1 Then
		$g = 1
	ElseIf $g < 0 Then
		$g = 0
	EndIf
	If $b > 1 Then
		$b = 1
	ElseIf $b < 0 Then
		$b = 0
	EndIf
	Return '0x' & Hex(Dec(Hex($r * 255, 2) & Hex($g * 255, 2) & Hex($b * 255, 2)), 6)
EndFunc   ;==>rgb2hex
;========================================================================================
Func LogEntry($text, $br = 1)
	If $br Then
		GUICtrlSetData($LogView, @CRLF & @HOUR & ":" & @MIN & ":" & @SEC & " " & @YEAR & "/" & @MON & "/" & @MDAY & "  " & $text, 1)
	Else
		GUICtrlSetData($LogView, $text, 1)
	EndIf
	Return
EndFunc   ;==>LogEntry
;========================================================================================
Func OpenFile()
	Local $srcfile, $suffix
	$srcfile = FileOpenDialog('Select a Gradient-File', @WorkingDir, "GIMP Gradient (*.ggr)|Texture Maker Gradient (*.tmg)", 1)
	If FileExists($srcfile) Then
		$suffix = StringUpper(StringRight($srcfile, 3))
		Switch $suffix
			Case "GGR"
				$segments = LoadGGR($srcfile)
				If GUICtrlRead($Check_Preview) = $GUI_CHECKED Then GradientRefresh()
			Case "TMG"
				$segments = LoadTMG($srcfile)
		EndSwitch
	ElseIf $srcfile = "" Then
		SetStatusMessage("", 0)
		SetStatusMessage("", 1)
		SetStatusMessage("", 2)
	Else
		SetStatusMessage("File: " & $srcfile & " not found!", 0)
	EndIf
	Return $srcfile
EndFunc   ;==>OpenFile
;========================================================================================
Func SelectDir()
	Local $dir
	$dir = FileSelectFolder("", "")
	If StringLen($dir) > 3 Then $dir &= "\"
	Return $dir
EndFunc   ;==>SelectDir
;========================================================================================
Func SaveFile($name, $txt)
	Local $file
	$file = FileOpen($name, 2)
	If @error <> -1 Then FileWrite($file, $txt)
	FileClose($file)
	Return
EndFunc   ;==>SaveFile