;==============================================================================
; GIMP-Gradienten laden
Func LoadGGR($srcfile)
	Local $data[14]
	Local $i, $file, $line
	Global $gradient[256][14]
	$i = 0
	$file = FileOpen($srcfile, 0)
	If $file = -1 Then
		SetStatusMessage("ERROR open: " & $srcfile, 0)
		Return
	EndIf
	$line = FileReadLine($file) ; "GIMP Gradient"
	If Not $line = "GIMP Gradient" Then
		SetStatusMessage("Not a GIMP Gradient: " & $srcfile, 0)
		Return
	EndIf
	$GRDname = StringReplace(FileReadLine($file), "Name: ", "") ; Name
	$line = FileReadLine($file) ; Sections
	LogEntry(@CRLF & "Loaded: " & $srcfile & @CRLF, 0)
	LogEntry(@CRLF & "GIMP-Gradient Data:" & @CRLF, 0)
	While 1
		$line = FileReadLine($file)
		If @error = -1 Then ExitLoop
		LogEntry($line & @CRLF, 0)
		If $debug Then Sleep(1000)
		SetStatusMessage("Reading: " & $line, 0)
		$data = StringSplit($line, " ")
		For $j = 1 To UBound($data) - 1
			If $j > 13 Then ExitLoop
			$gradient[$i][$j] = $data[$j]
		Next
		$i = $i + 1
		If $i > 255 Then ExitLoop
	WEnd
	SetStatusMessage($srcfile & " loaded.", 0)
	SetStatusMessage($GRDname, 1)
	SetStatusMessage($i + 1, 2)
	FileClose($file)
	Return $i
EndFunc   ;==>LoadGGR
;==============================================================================
;==============================================================================
; Texture Maker Gradienten laden
Func LoadTMG($file)
	;Local $data [14]
	Global $gradient[256][14]
	$i = 0
	$file = FileOpen($srcfile, 0)
	If $file = -1 Then
		SetStatusMessage("ERROR open: " & $srcfile, 0)
		Return
	EndIf
	Local $line = FileReadLine($file)
	If $debug Then Sleep(1000)
	SetStatusMessage("Reading: " & $line, 0)
	SetStatusMessage($srcfile & " loaded.", 0)
	SetStatusMessage($GRDname, 1)
	SetStatusMessage($i, 2)
	FileClose($file)
	Return $i
EndFunc   ;==>LoadTMG
;==============================================================================